## pgrouting 3.0.0~rc1

=== CMakeLists.txt ===
#
# Format convention
# - command (lower case)
# - VARIABLE (upper case)
# (http://www.cmake.org/cmake/help/v2.8.12/cmake.html)
#

cmake_minimum_required(VERSION 3.2 FATAL_ERROR)

if(POLICY CMP0046)
    cmake_policy(SET CMP0046 NEW)
endif()

if(POLICY CMP0054)
    cmake_policy(SET CMP0054 NEW)
endif()

if ( ${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR} )
        message(FATAL_ERROR "In-source builds not allowed.
        Please make a new directory (called a build directory) and run CMake from there.
        You may need to remove CMakeCache.txt." )
endif()

#---------------------------------------------
# Setting kind of build
#---------------------------------------------

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
include(pgr/BuildType)


#---------------------------------------------
#---------------------------------------------
#---------------------------------------------

project(PGROUTING VERSION 3.0.0
    LANGUAGES C CXX )
set(PGROUTING_VERSION_DEV "-rc1")

include(pgr/GitInfo)

include(pgr/Version)
add_definitions(-DPGROUTING_VERSION="${PGROUTING_VERSION}${PGROUTING_VERSION_DEV}")
set(PGROUTING_LIB_NAME "pgrouting-${PGROUTING_LIB_VERSION}")

string(TIMESTAMP COMPILATION_DATE "%Y/%m/%d")



#=============================================
# Set the working directories
#=============================================

#---------------------------------------------
#  PGROUTING_SOURCE_NAMES
#---------------------------------------------
include(pgr/Configure)


#---------------------------------------------
# minimum versions
#---------------------------------------------
set(DOXYGEN_MINIMUM_VERSION "1.7")
set(SPHINX_MINIMUM_VERSION "1.1")
set(POSTGRESQL_MINIMUM_VERSION "9.2.0")
set(BOOST_MINIMUM_VERSION "1.53")
set(POSTGIS_MINIMUM_VERSION "2.0.0")
set(GNU_CXX_MINIMUM_VERSION "4.6")
set(MSVC_CXX_MINIMUM_VERSION "18.0")

message(STATUS "DOXYGEN_MINIMUM_VERSION=${DOXYGEN_MINIMUM_VERSION}")
message(STATUS "SPHINX_MINIMUM_VERSION=${SPHINX_MINIMUM_VERSION}")
message(STATUS "POSTGRESQL_MINIMUM_VERSION=${POSTGRESQL_MINIMUM_VERSION}")
message(STATUS "POSTGIS_MINIMUM_VERSION=${POSTGIS_MINIMUM_VERSION}")
message(STATUS "GNU_CXX_MINIMUM_VERSION=${GNU_CXX_MINIMUM_VERSION}")
message(STATUS "CLANG_CXX_MINIMUM_VERSION=${CLANG_CXX_MINIMUM_VERSION}")
message(STATUS "MSVC_CXX_MINIMUM_VERSION=${MSVC_CXX_MINIMUM_VERSION}")


#---------------------------------------------
# adding cmake modules
#---------------------------------------------

foreach(dir ${CMAKE_MODULE_PATH})
    message(STATUS "dir='${dir}'")
endforeach()

include(MacroLibrary)
include(TargetDistclean)

#---------------------------------------------
# C++ Compiler requirements
#---------------------------------------------

include(CheckCXXCompilerFlag)

CHECK_CXX_COMPILER_FLAG("-std=c++0x" COMPILER_SUPPORTS_CXX0X)
CHECK_CXX_COMPILER_FLAG("-std=c++11" COMPILER_SUPPORTS_CXX11)
if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
    if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS GNU_CXX_MINIMUM_VERSION)
        message(FATAL_ERROR "GCC version must be at least ${GNU_CXX_MINIMUM_VERSION}!
        Found version ${CMAKE_CXX_COMPILER_VERSION}")
    endif()
elseif ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC")
    if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS MSVC_CXX_MINIMUM_VERSION)
        message(FATAL_ERROR "MSVC version must be at least ${MSVC_CXX_MINIMUM_VERSION}!")
    endif()
else()
    message(STATUS "Unknown compiler minimum version for ${CMAKE_CXX_COMPILER_ID}")
endif()

if(COMPILER_SUPPORTS_CXX11)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
    message(STATUS "Using  -std=c++11.")
elseif(COMPILER_SUPPORTS_CXX0X)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
    message(STATUS "Using  -std=c++0x.")
else()
    message(STATUS "The compiler ${CMAKE_CXX_COMPILER} has no C++0x or C++11 flags support.")
endif()
set(COMPILER_VERSION "${CMAKE_CXX_COMPILER_ID}-${CMAKE_CXX_COMPILER_VERSION}")




#-----------------------------------------------------------------------------
#-----------------------------------------------------------------------------
# Windows compiler flags
#-----------------------------------------------------------------------------
#-----------------------------------------------------------------------------


if(WIN32 AND NOT MSVC)
    set(OS_BUILD  $ENV{OS_BUILD})
    if(NOT OS_BUILD)
        set(OS_BUILD "64")
    endif(NOT OS_BUILD)
    set(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH}:/c/ming${OS_BUILD}/projects/pgx${OS_BUILD}/pg92)
    if (NOT BOOST_ROOT)
        set(BOOST_ROOT c:/ming${OS_BUILD}/msys/local)
    endif(NOT BOOST_ROOT)

    if (PGROUTING_DEBUG)
        message(STATUS "OS_BUILD=${OS_BUILD}")
        message(STATUS "BOOST_ROOT=${BOOST_ROOT}")
        message(STATUS "CMAKE_PREFIX_PATH=${CMAKE_PREFIX_PATH}")
    endif()
endif(WIN32 AND NOT MSVC)

if(WIN32 AND MSVC)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_CRT_SECURE_NO_DEPRECATE")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_SCL_SECURE_NO_DEPRECATE")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_CRT_SECURE_NO_WARNINGS")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_SCL_SECURE_NO_WARNINGS")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_CRT_NONSTDC_NO_DEPRECATE")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -EHsc")
endif()

#-----------------------------------------------------------------------------
#-----------------------------------------------------------------------------
#-----------------------------------------------------------------------------
# Finding prerequisites
#-----------------------------------------------------------------------------
#-----------------------------------------------------------------------------
#-----------------------------------------------------------------------------

#---------------------------------------------
#---------------------------------------------
# Perl
#---------------------------------------------
#---------------------------------------------
include(FindPerl)
if(NOT PERL_EXECUTABLE)
    message(FATAL_ERROR " Please check your Perl installation.")
endif(NOT PERL_EXECUTABLE)

#---------------------------------------------
#---------------------------------------------
# PostgreSQL
#---------------------------------------------
#---------------------------------------------
find_package(PostgreSQL)
if(NOT POSTGRESQL_FOUND)
    message(FATAL_ERROR " Please check your PostgreSQL installation.")
endif(NOT POSTGRESQL_FOUND)

if(NOT POSTGRESQL_VERSION_STRING)
    message(FATAL_ERROR "pg_config was not found. Please check your PostgreSQL installation!")
endif()

string(SUBSTRING "${POSTGRESQL_VERSION_STRING}" 11 -1 POSTGRESQL_VERSION)

# for XbetaY XalphaY XrcY -> X.Y
string(REGEX REPLACE "^([0-9]+)[beta|alpha|rc|devel].*" "\\1.0" POSTGRESQL_VERSION ${POSTGRESQL_VERSION})

#for X.Y.Z -> XY  Y<10
string(REGEX REPLACE "^([0-9]+)\\.([0-9]+).*" "\\1\\2" PGSQL_VERSION ${POSTGRESQL_VERSION})


if("${POSTGRESQL_VERSION}" VERSION_LESS "${POSTGRESQL_MINIMUM_VERSION}")
    message(FATAL_ERROR " PostgreSQL ${POSTGRESQL_MINIMUM_VERSION} or greater is required.")
endif("${POSTGRESQL_VERSION}" VERSION_LESS "${POSTGRESQL_MINIMUM_VERSION}")

#-------
include_directories(${POSTGRESQL_INCLUDE_DIR})
if(WIN32)
    include_directories(${POSTGRESQL_INCLUDE_DIR}/port/win32)
    if(MSVC)
        include_directories(${POSTGRESQL_INCLUDE_DIR}/port/win32_msvc/)
    endif(MSVC)
endif(WIN32)

add_definitions(-DPGSQL_VERSION=${PGSQL_VERSION})
message(STATUS "PGSQL_VERSION=${PGSQL_VERSION}")


#---------------------------------------------
#---------------------------------------------
# Boost
#---------------------------------------------
#---------------------------------------------
find_package(Boost ${BOOST_MINIMUM_VERSION})
if(Boost_FOUND)
    include_directories(${Boost_INCLUDE_DIRS})
    message(STATUS "Boost headers were found here: ${Boost_INCLUDE_DIRS}")
else()
    message(FATAL_ERROR " Please check your Boost installation ")
endif()
set(BOOST_VERSION "${Boost_MAJOR_VERSION}.${Boost_MINOR_VERSION}.${Boost_SUBMINOR_VERSION}")


# Boost for Chinese postman needs 1.55 at least
# dijkstra_shortest_paths.hpp has an error fix on 1.55
#  error affects prim
# BOOST_VERSION_OK if 1, use the boost file copy in the repository
if ("${Boost_MAJOR_VERSION}.${Boost_MINOR_VERSION}.${Boost_SUBMINOR_VERSION}" VERSION_LESS "1.55.0")
    set(BOOST_VERSION_OK "0")
else()
    set(BOOST_VERSION_OK "1")
endif()

# Boost Geometry structure is different
if ("${Boost_MAJOR_VERSION}.${Boost_MINOR_VERSION}.${Boost_SUBMINOR_VERSION}" VERSION_LESS "1.56.0")
    set(BOOST_Geometry_VERSION_OK "0")
else()
    set(BOOST_Geometry_VERSION_OK "1")
endif()



message(STATUS "Boost VERSION ${Boost_MAJOR_VERSION}.${Boost_MINOR_VERSION}.${Boost_SUBMINOR_VERSION}")
message(STATUS "BOOST_VERSION_OK ${BOOST_VERSION_OK}")
message(STATUS "BOOST_Geometry_VERSION_OK ${BOOST_Geometry_VERSION_OK}")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DBOOST_VERSION_OK=${BOOST_VERSION_OK} -DBOOST_Geometry_VERSION_OK=${BOOST_Geometry_VERSION_OK}")

#---------------------------------------------
#---------------------------------------------
# PGROUTING includes
#---------------------------------------------
#---------------------------------------------

set(PGROUTING_INCLUDE_DIRECTORIES
    ${PGROUTING_SOURCE_DIR}/include
    )

#-------
include_directories(${PGROUTING_INCLUDE_DIRECTORIES})


#---------------------------------------------
if (PGROUTING_DEBUG)
    message(STATUS "PERL_VERSION_STRING = ${PERL_VERSION_STRING}")
    message(STATUS "POSTGRESQL_VERSION is ${PGSQL_VERSION}")
    message(STATUS "PGSQL_VERSION is ${PGSQL_VERSION}")
    message(STATUS "BOOST_VERSION_OK ${BOOST_VERSION_OK}")
    message(STATUS "PGROUTING_INCLUDE_DIRECTORIES = ${PGROUTING_INCLUDE_DIRECTORIES}")
    message(STATUS "POSTGRESQL_INCLUDE_DIR = ${POSTGRESQL_INCLUDE_DIR}")
    message(STATUS "Boost_INCLUDE_DIRS = ${Boost_INCLUDE_DIRS}")
endif()


#-----------------------------------------------------------------------------
#-----------------------------------------------------------------------------
# Posgres installation directories
#-----------------------------------------------------------------------------
#-----------------------------------------------------------------------------



#---------------------------------------------
# library directory
#---------------------------------------------
execute_process(
    COMMAND ${POSTGRESQL_PG_CONFIG} --pkglibdir
    OUTPUT_STRIP_TRAILING_WHITESPACE
    OUTPUT_VARIABLE LIB_DIR)

if(NOT LIB_DIR)
    message(FATAL_ERROR "pg_config --pkglibdir failed to return a value. Please check your PostgreSQL installation!")
endif()

#-------
set(LIBRARY_INSTALL_PATH ${LIB_DIR})

#---------------------------------------------
# extension directory
#---------------------------------------------

execute_process(
    COMMAND ${POSTGRESQL_PG_CONFIG} --sharedir
    OUTPUT_STRIP_TRAILING_WHITESPACE
    OUTPUT_VARIABLE SHARE_DIR)

#-------
if(SHARE_DIR)
    set(SHARE_DIR "${SHARE_DIR}/extension")
else(SHARE_DIR)
    message(FATAL_ERROR "pg_config --sharedir failed to return a value. Please check your PostgreSQL installation!")
endif(SHARE_DIR)

#---------------------------------------------
if (PGROUTING_DEBUG)
    message(STATUS "Install directory for libraries is set to ${LIB_DIR}")
    message(STATUS "Extension directory for SQL files is set to ${SHARE_DIR}")
endif()



#---------------------------------------------
# Special cases for windows
#---------------------------------------------

if(WIN32)
    message(STATUS "LINK_DIRECTORIES = ${POSTGRESQL_LIBRARIES}")
    link_directories(${POSTGRESQL_LIBRARIES} ${LIB_DIR})
    link_libraries(postgres)
endif()

#-----------------------------------------------------------------------------

if (PGROUTING_DEBUG)
    get_property(dirs DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY INCLUDE_DIRECTORIES)
    foreach(dir ${dirs})
        message(STATUS "dir='${dir}'")
    endforeach()

=== doc/CMakeLists.txt ===
#
# Find Sphinx
# Find Sphinx executable to build documentation
# Source: https://ericscottbarr.com/blog/2012/03/sphinx-and-cmake-beautiful-documentation-for-c-projects/
#
# Daniel Kastl 03/2013
#

#---------------------------------------------
# Kind of sphinx output
#---------------------------------------------

option(WITH_DOC
    "Set ON|OFF (default=OFF) to build Documentation library tree" OFF)

option(LOCALE
    "Set ON|OFF (default=OFF) to build ithe latest pot/po files" OFF)

option(WITH_ALL_DOC
    "Set ON|OFF (default=OFF) to build Documentation library tree" OFF)

#option(PDF
#    "Set ON|OFF (default=OFF) to build Documentation library tree as PDF" OFF)

option(BUILD_LATEX
    "Set ON|OFF (default=OFF) to build Documentation library tree as PDF" OFF)

option(SINGLEHTML
    "Set ON|OFF (default=OFF) to build Documentation library tree as SINGLE HTML" OFF)

option(BUILD_HTML
    "Set ON|OFF (default=OFF) to build Documentation library tree as HTML" ON)

option(BUILD_MAN
    "Set ON|OFF (default=OFF) to build Documentation library tree as MAN page" OFF)

option(EPUB
    "Set ON|OFF (default=OFF) to build Documentation library tree as EPUB page" OFF)

option(DUMMY
    "Set ON|OFF (default=OFF) for debugging purposes" OFF)

if (LOCALE)
    set(WITH_DOC ON)
endif()

if (NOT WITH_DOC)
    return()
endif()

foreach(opt BUILD_HTML BUILD_LATEX BUILD_MAN SINGLEHTML EPUB DUMMY)
    if (${${opt}} OR WITH_ALL_DOC)
        string(TOLOWER ${opt} val)
        string(REPLACE "build_" "" val ${val})
        list(APPEND PGROUTING_DOC_TARGETS ${val})
        set(WITH_DOC ON)
    endif()
endforeach()



message(STATUS "PGROUTING_DOC_TARGETS = ${PGROUTING_DOC_TARGETS}")

#---------------------------------------------
#---------------------------------------------
#---------------------------------------------

# LANGUAGES SETINGS

#---------------------------------------------
#---------------------------------------------
#---------------------------------------------

#---------------------------------------------
# Available Languages
# English is always built
#---------------------------------------------
set(PGROUTING_SUPPORTED_LANGUAGES  "de"   "es"  "fr"  "it"  "ja"  "ru")
set(PGROUTING_ENGLISH "en")

#---------------------------------------------
# Language options
#---------------------------------------------
option(WITH_ALL_LANG
    "Set ON|OFF (default=OFF) to build all the supported languages:
    Main Language will always be built:
    ${PGROUTING_ENGLISH}
    Optional languages:
    ${PGROUTING_SUPPORTED_LANGUAGES}

    When OFF and want to build specific optional language, use the language code in capital letters:
    -D ES=ON
    "
    OFF
    )

foreach(lang ${PGROUTING_SUPPORTED_LANGUAGES})
    string(TOUPPER ${lang} val)
    option(${val}
        "Set ON|OFF (default=OFF) build ${lang} Documentation" OFF)
endforeach()

#---------------------------------------------
# Catching the language options to be build
#---------------------------------------------
foreach(lang ${PGROUTING_SUPPORTED_LANGUAGES})
    string(TOUPPER ${lang} opt)
    if (${opt} OR WITH_ALL_LANG)
        set (langFound  "1")
        list(APPEND PGROUTING_BUILD_LANGUAGES ${lang})
    endif()
endforeach()

if (langFound)
    set(PGROUTING_ENGLISH "")
endif()

#---------------------------------------------
# All languages po files are to be generated
#---------------------------------------------

set (SPHINXINTL_LANGUAGE  ${PGROUTING_ENGLISH})
foreach(lang ${PGROUTING_BUILD_LANGUAGES})
    set(SPHINXINTL_LANGUAGE "${SPHINXINTL_LANGUAGE},${lang}")
endforeach()


list(APPEND PGROUTING_BUILD_LANGUAGES  ${PGROUTING_ENGLISH})
message(STATUS "PGROUTING_BUILD_LANGUAGES = ${PGROUTING_BUILD_LANGUAGES}")
message(STATUS "SPHINXINTL_LANGUAGE = ${SPHINXINTL_LANGUAGE}")


if(NOT WITH_DOC)
    return()
endif()


#---------------------------------------------
# Checking for prerequisites
#---------------------------------------------
find_package(Sphinx ${SPHINX_MINIMUM_VERSION} REQUIRED)

if (NOT SPHINX_FOUND)
    message(FATAL_ERROR "Sphinx not found.
    Cannot generate documentation!
    Install Sphinx or build without documentation")
endif()

if (SPHINX_VERSION VERSION_LESS 1.0)
    message(WARNING "Your Sphinx version is too old!
    This project requires Sphinx v${SPHINX_MINIMUM_VERSION} or above to produce
    proper documentation (you have v${SPHINX_VERSION}).
    You will get output but it will have errors.")
endif()

#pip install rst2pdf



#---------------------------------------------
# Kind of "looks"
#---------------------------------------------
option(DOC_USE_BOOTSTRAP
    "Set ON|OFF (default=ON) to build Documentation library tree as MAN page" OFF)

if (DOC_USE_BOOTSTRAP)
    set(SPHINX_INCLUDE "import sphinx_bootstrap_theme")
    set(SPHINX_THEME "bootstrap")
    set(SPHINX_THEME_DIR "sphinx_bootstrap_theme.get_html_theme_path()")
    set(SPHINX_THEME_OPTIONS "'source_link_position': \"none\",")
else()
    set(SPHINX_INCLUDE "")
    set(SPHINX_THEME "haiku")
    set(SPHINX_THEME_DIR "['']")
    set(SPHINX_THEME_OPTIONS "")
endif()




# configured documentation tools and intermediate build results
# TODO for 3.0 Use _build
# set(PGR_DOCUMENTATION_BUILD_DIR "${CMAKE_CURRENT_BINARY_DIR}/_build")
set(PGR_DOCUMENTATION_BUILD_DIR "${CMAKE_CURRENT_BINARY_DIR}")
set(PGR_DOCUMENTATION_SOURCE_DIR "${CMAKE_CURRENT_BINARY_DIR}")

message(STATUS "PGR_DOCUMENTATION_BUILD_DIR = ${PGR_DOCUMENTATION_BUILD_DIR}")


#---------------------------------------------
# Adding documentation directories
#---------------------------------------------
foreach (subdir ${PGROUTING_DOC_DIRECTORIES} "src")
    add_subdirectory("${subdir}")
    add_subdirectory("../docqueries/${subdir}" "build/doc/${subdir}")
endforeach()

add_subdirectory("images")


configure_file("../tools/testers/sampledata.sql" "${PGR_DOCUMENTATION_SOURCE_DIR}/sampledata/sampledata.sql")


#TODO ???
#add_subdirectory("static")
#add_subdirectory("themes")
file(COPY "${CMAKE_CURRENT_SOURCE_DIR}/_static" DESTINATION "${PGR_DOCUMENTATION_SOURCE_DIR}")
file(COPY "${CMAKE_CURRENT_SOURCE_DIR}/_themes" DESTINATION "${PGR_DOCUMENTATION_SOURCE_DIR}")


configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/conf.py.in"
    "${PGR_DOCUMENTATION_SOURCE_DIR}/conf.py"
    @ONLY)

# Add documentation to targets


#if (LATEX)
if (FALSE)
    find_package(LATEX)
    if (NOT LATEX_COMPILER)
        message("Couldn't find Latex, can't build latex docs using Sphinx")
    else()
        message(STATUS "LATEX_COMPILER = ${LATEX_COMPILER}")
    endif()
endif()

set(ENV{SPHINXINTL_LANGUAGE} ${SPHINXINTL_LANGUAGE})

if (LOCALE)
    add_custom_target(locale
        COMMAND ${SPHINX_EXECUTABLE}
        -b gettext
        -c "${PGR_DOCUMENTATION_SOURCE_DIR}"
        "${PGR_DOCUMENTATION_SOURCE_DIR}"
        "${CMAKE_SOURCE_DIR}/locale/pot"

        COMMAND sphinx-intl update -d ${CMAKE_SOURCE_DIR}/locale -l en
    #COMMAND sphinx-intl update -p ${CMAKE_SOURCE_DIR}/locale/pot -d ${CMAKE_SOURCE_DIR}/locale --language=${SPHINXINTL_LANGUAGE}
    #COMMAND sphinx-intl update-txconfig-resources --locale-dir ${CMAKE_SOURCE_DIR}/locale --pot-dir ${CMAKE_SOURCE_DIR}/locale/pot --transifex-project-name pgrouting


    COMMENT "Generating POT files ..."
    SOURCES ${PGROUTING_DOC_FILES}
    )
    return()
endif()


# The doc target will build all documentation targets.
add_custom_target(doc
    COMMENT "Building documentation with Sphinx")


foreach (target ${PGROUTING_DOC_TARGETS})
    add_custom_target("${target}"
        COMMENT "Building ${target} documentation with Sphinx")

    configure_file(
        "${CMAKE_CURRENT_SOURCE_DIR}/forward.html"
        "${PGR_DOCUMENTATION_BUILD_DIR}/${target}/index.html")

    foreach (lang ${PGROUTING_BUILD_LANGUAGES})
        add_custom_target(
            "${target}-${lang}"
            COMMAND ${SPHINX_EXECUTABLE}
            #-q  # Enable for quiet mode
            #-Q  # Enable for even more quiet mode
            -v   # increase verbosity
            #-E  # don't use a saved environment, always read all file
            #-a  # write all files; default is to only write new and changed files
            -b ${target}
            -D language='${lang}'
            -c "${PGR_DOCUMENTATION_SOURCE_DIR}"
            "${PGR_DOCUMENTATION_SOURCE_DIR}"
            "${PGR_DOCUMENTATION_BUILD_DIR}/${target}/${lang}"

            COMMENT "Generating ${target}/${lang} documentation ..."
            SOURCES ${PGROUTING_DOC_FILES}  ${PGROUTING_IMG_FILES}
            DEPENDS ${PGROUTING_DOC_FILES}  ${PGROUTING_IMG_FILES}
            )
        add_dependencies(${target} "${target}-${lang}")

    endforeach()
    add_dependencies(doc "${target}")
endforeach()



if(FALSE)
    # AND ${target} MATCHES "latex" AND LATEX_COMPILER)
    add_custom_target(pdf-${lang}
        COMMENT "Building documentation with Sphinx")

    add_custom_command(
        TARGET pdf-${lang} POST_BUILD
        #fixes: Underfull \hbox (badness 10000) in paragraph
        #perl -pi -e 's/warning/warning /' pgRoutingDocumentation.tex
        COMMAND pdflatex -interaction=nonstopmode "pgRoutingDocumentation.tex" > /dev/null 2>&1
        WORKING_DIRECTORY "${PGR_DOCUMENTATION_BUILD_DIR}/pdf/${lang}"
        DEPENDS ${target}-${lang}
        COMMENT "Converting Latex to PDF format")

endif()

=== sql/CMakeLists.txt ===
#
# Format convention
# - command (lower case)
# - VARIABLE (upper case)
# (http://www.cmake.org/cmake/help/v2.8.12/cmake.html)
#



#set (PGROUTING_DEBUG "1")

#-------------------
# add the signatrues subdirectory
#-------------------

add_subdirectory(sigs)


#-------------------
# From the parent get the subdirectories that have the SQL files
#
# configuring the PGROUTING_SQL_FILES variable
#-------------------

set(PGROUTING_MODULE_PATHNAME "$libdir/libpgrouting-${PGROUTING_LIB_VERSION}")

foreach (subdir ${PGROUTING_SQL_DIRECTORIES})
    add_subdirectory(${subdir})
endforeach()

if (PGROUTING_DEBUG)
    message(STATUS "PGROUTING_SQL_FILES=")
    message(STATUS "PGROUTING_MODULE_PATHNAME ${PGROUTING_MODULE_PATHNAME}")
    foreach (f ${PGROUTING_SQL_FILES})
        message(STATUS ${f})
    endforeach()
endif()



#-------------------
# TARGET: PGROUTING_SQL_FILE
#
# Builds:  pgrouting--${PGROUTING_VERSION}.sql
#
# add the scripts subdirectory
# the variable ${PGROUTING_SQL_FILES} should already be set at this point
#
# has the perl for building the current sql file
# has the perl for building the update files
#-------------------

set(PGROUTING_CURRENT_SQL_FILE "pgrouting--${PGROUTING_VERSION}.sql")

# subdirectory that has the perl files
add_subdirectory(scripts)



add_custom_command(
    OUTPUT ${PGROUTING_CURRENT_SQL_FILE}
    COMMAND ${PERL_EXECUTABLE} ./scripts/build-extension-file.pl '${PGROUTING_SQL_FILES}'
    DEPENDS
    scripts/build-extension-file.pl
    ${PGROUTING_SQL_FILES}
    )

add_custom_target(PGROUTING_SQL_FILE ALL
    DEPENDS
    ${PGROUTING_CURRENT_SQL_FILE}
    )

#-------------------
# TARGET: update_files
#-------------------

if (PGROUTING_DEBUG)
    message(STATUS "OLD_SIGNATURES=")
    foreach (s ${OLD_SIGNATURES})
        message(STATUS ${s})
    endforeach()
endif()

foreach (old_s ${OLD_SIGNATURES})
    SET (UPDATE_FILES ${UPDATE_FILES} pgrouting--${old_s}--${PGROUTING_VERSION}.sql)
    SET (PGROUTING_SQL_FILES_TO_INSTALL ${PGROUTING_SQL_FILES_TO_INSTALL} "${CMAKE_CURRENT_BINARY_DIR}/pgrouting--${old_s}--${PGROUTING_VERSION}.sql")
    add_custom_command(
        OUTPUT pgrouting--${old_s}--${PGROUTING_VERSION}.sql
        COMMAND ${PERL_EXECUTABLE} ./scripts/build-extension-update-files1.pl ${old_s} ${PGROUTING_DEBUG}
        DEPENDS
        ./scripts/build-extension-update-files1.pl
        ${PGROUTING_CURRENT_SQL_FILE}
        PGROUTING_SQL_FILE
        ./sigs/pgrouting--${old_s}.sig
        )
endforeach()

add_custom_target(update_files ALL
    DEPENDS
    ${UPDATE_FILES}
    )

SET(PGROUTING_SQL_FILES_TO_INSTALL  ${PGROUTING_SQL_FILES_TO_INSTALL} ${CMAKE_CURRENT_BINARY_DIR}/${PGROUTING_CURRENT_SQL_FILE} "${CMAKE_CURRENT_BINARY_DIR}/common/pgrouting.control" PARENT_SCOPE)

=== doc/allpairs/CMakeLists.txt ===

SET(LOCAL_FILES
    allpairs-family.rst
    pgr_floydWarshall.rst
    pgr_johnson.rst
    )

foreach (f ${LOCAL_FILES})
    configure_file(${f} "${PGR_DOCUMENTATION_SOURCE_DIR}/${f}")
    list(APPEND LOCAL_DOC_FILES  ${PGR_DOCUMENTATION_SOURCE_DIR}/${f})
endforeach()

set(PGROUTING_DOC_FILES ${PGROUTING_DOC_FILES} ${LOCAL_DOC_FILES} PARENT_SCOPE)

=== doc/alpha_shape/CMakeLists.txt ===

SET(LOCAL_FILES
    pgr_alphaShape.rst
    )

foreach (f ${LOCAL_FILES})
    configure_file(${f} "${PGR_DOCUMENTATION_SOURCE_DIR}/${f}")
    list(APPEND LOCAL_DOC_FILES  ${PGR_DOCUMENTATION_SOURCE_DIR}/${f})
endforeach()

set(PGROUTING_DOC_FILES ${PGROUTING_DOC_FILES} ${LOCAL_DOC_FILES} PARENT_SCOPE)

=== doc/astar/CMakeLists.txt ===

SET(LOCAL_FILES
    aStar-family.rst
    pgr_aStarCost.rst
    pgr_aStarCostMatrix.rst
    pgr_aStar.rst
    )

foreach (f ${LOCAL_FILES})
    configure_file(${f} "${PGR_DOCUMENTATION_SOURCE_DIR}/${f}")
    list(APPEND LOCAL_DOC_FILES  ${PGR_DOCUMENTATION_SOURCE_DIR}/${f})
endforeach()

set(PGROUTING_DOC_FILES ${PGROUTING_DOC_FILES} ${LOCAL_DOC_FILES} PARENT_SCOPE)

=== doc/bdAstar/CMakeLists.txt ===

SET(LOCAL_FILES
    bdAstar-family.rst
    pgr_bdAstar.rst
    pgr_bdAstarCost.rst
    pgr_bdAstarCostMatrix.rst
    )

foreach (f ${LOCAL_FILES})
    configure_file(${f} "${PGR_DOCUMENTATION_SOURCE_DIR}/${f}")
    list(APPEND LOCAL_DOC_FILES  ${PGR_DOCUMENTATION_SOURCE_DIR}/${f})
endforeach()

set(PGROUTING_DOC_FILES ${PGROUTING_DOC_FILES} ${LOCAL_DOC_FILES} PARENT_SCOPE)

=== doc/bdDijkstra/CMakeLists.txt ===

SET(LOCAL_FILES
    bdDijkstra-family.rst
    pgr_bdDijkstraCost.rst
    pgr_bdDijkstraCostMatrix.rst
    pgr_bdDijkstra.rst
    )

foreach (f ${LOCAL_FILES})
    configure_file(${f} "${PGR_DOCUMENTATION_SOURCE_DIR}/${f}")
    list(APPEND LOCAL_DOC_FILES  ${PGR_DOCUMENTATION_SOURCE_DIR}/${f})
endforeach()

set(PGROUTING_DOC_FILES ${PGROUTING_DOC_FILES} ${LOCAL_DOC_FILES} PARENT_SCOPE)

=== doc/bellman_ford/CMakeLists.txt ===

SET(LOCAL_FILES
    pgr_bellmanFord.rst
    pgr_edwardMoore.rst
    )

foreach (f ${LOCAL_FILES})
    configure_file(${f} "${PGR_DOCUMENTATION_SOURCE_DIR}/${f}")
    list(APPEND LOCAL_DOC_FILES  ${PGR_DOCUMENTATION_SOURCE_DIR}/${f})
endforeach()

set(PGROUTING_DOC_FILES ${PGROUTING_DOC_FILES} ${LOCAL_DOC_FILES} PARENT_SCOPE)

=== doc/breadthFirstSearch/CMakeLists.txt ===

SET(LOCAL_FILES
    pgr_breadthFirstSearch.rst
    pgr_binaryBreadthFirstSearch.rst    
    )

foreach (f ${LOCAL_FILES})
    configure_file(${f} "${PGR_DOCUMENTATION_SOURCE_DIR}/${f}")
    list(APPEND LOCAL_DOC_FILES  ${PGR_DOCUMENTATION_SOURCE_DIR}/${f})
endforeach()

set(PGROUTING_DOC_FILES ${PGROUTING_DOC_FILES} ${LOCAL_DOC_FILES} PARENT_SCOPE)

=== doc/chinese/CMakeLists.txt ===

SET(LOCAL_FILES
    chinesePostmanProblem-family.rst
    pgr_chinesePostmanCost.rst
    pgr_chinesePostman.rst
    )

foreach (f ${LOCAL_FILES})
    configure_file(${f} "${PGR_DOCUMENTATION_SOURCE_DIR}/${f}")
    list(APPEND LOCAL_DOC_FILES  ${PGR_DOCUMENTATION_SOURCE_DIR}/${f})
endforeach()

set(PGROUTING_DOC_FILES ${PGROUTING_DOC_FILES} ${LOCAL_DOC_FILES} PARENT_SCOPE)

=== doc/components/CMakeLists.txt ===

SET(LOCAL_FILES
    components-family.rst
	pgr_connectedComponents.rst
	pgr_strongComponents.rst
	pgr_biconnectedComponents.rst
	pgr_articulationPoints.rst
	pgr_bridges.rst
    )

foreach (f ${LOCAL_FILES})
    configure_file(${f} "${PGR_DOCUMENTATION_SOURCE_DIR}/${f}")
    list(APPEND LOCAL_DOC_FILES  ${PGR_DOCUMENTATION_SOURCE_DIR}/${f})
endforeach()

add_subdirectory("images")
set(PGROUTING_DOC_FILES ${PGROUTING_DOC_FILES} ${LOCAL_DOC_FILES} PARENT_SCOPE)
set(PGROUTING_IMG_FILES ${PGROUTING_IMG_FILES} PARENT_SCOPE)

=== debian/changelog ===
pgrouting (3.0.0~rc1-1.pgdg110+1) bullseye-pgdg; urgency=medium

  * Rebuild for bullseye-pgdg.
  * No source changes.

 -- PostgreSQL on Debian and Ubuntu <pgsql-pkg-debian@lists.postgresql.org>  Tue, 03 Dec 2019 07:19:41 +0100

pgrouting (3.0.0~rc1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release candidate.
  * Update copyright file.
  * Refresh patches.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 03 Dec 2019 07:19:41 +0100

pgrouting (3.0.0~beta-1) unstable; urgency=medium

  * Team upload.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 11 Nov 2019 05:51:15 +0100

pgrouting (3.0.0~beta-1~exp2) experimental; urgency=medium

  * Team upload.
  * Update packaging for postgresql-12.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 29 Oct 2019 06:08:01 +0100

pgrouting (3.0.0~beta-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream beta release.
  * Bump Standards-Version to 4.4.1, no changes.
  * Add Provides for virtual package without PostgrSQL version.
  * Update watch file to also match pre-releases.
  * Drop CGAL build dependency, no longer required.
  * Update copyright file, changes:
    - Update copyright years for copyright holders
    - Add new copyright holders
    - Add license & copyright for Boost sources
  * Refresh patches.
  * Drop unused override for file-references-package-build-path.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 20 Oct 2019 08:44:13 +0200

pgrouting (2.6.3-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 05 Sep 2019 18:10:48 +0200

pgrouting (2.6.2-2) unstable; urgency=medium

  * Team upload.

  [ Bas Couwenberg ]
  * Bump Standards-Version to 4.4.0, no changes.
  * Drop unused override for testsuite-autopkgtest-missing.
  * Update gbp.conf to use --source-only-changes by default.
  * Drop python-sphinx build dependency.
  * Add lintian override for file-references-package-build-path.

  [ Christoph Berg ]
  * Also depend on postgresql-PGVERSION-postgis-scripts, the postgis extension
    is needed to create the pgrouting extension.
  * Tests: create the extension.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 27 Jul 2019 14:48:05 +0200

=== debian/control ===
Source: pgrouting
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Michael Fladischer <FladischerMichael@fladi.at>
Section: misc
Priority: optional
Build-Depends: cmake (>= 3.2),
               debhelper (>= 9),
               libboost-graph-dev,
               libjs-mathjax,
               postgis,
               postgresql-server-dev-all,
               python3-sphinx (>= 1.0.7+dfsg),
               rdfind,
Standards-Version: 4.4.1
Vcs-Browser: https://salsa.debian.org/debian-gis-team/pgrouting
Vcs-Git: https://salsa.debian.org/debian-gis-team/pgrouting.git
Homepage: https://www.pgrouting.org

Package: postgresql-9.4-pgrouting
Architecture: any
Depends: postgresql-9.4-pgrouting-scripts (>= ${source:Version}),
         postgresql-9.4,
         postgresql-9.4-postgis,
         postgresql-9.4-postgis-scripts,
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: postgresql-9.4-pgrouting-doc
Provides: postgresql-pgrouting
Description: Routing functionality support for PostgreSQL/PostGIS
 pgRouting extends the PostGIS/PostgreSQL geospatial database to provide
 geospatial routing and other network analysis functionality.
 .
 This package supports PostgreSQL 9.4.

Package: postgresql-9.5-pgrouting
Architecture: any
Depends: postgresql-9.5-pgrouting-scripts (>= ${source:Version}),
         postgresql-9.5,
         postgresql-9.5-postgis,
         postgresql-9.5-postgis-scripts,
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: postgresql-9.5-pgrouting-doc
Provides: postgresql-pgrouting
Description: Routing functionality support for PostgreSQL/PostGIS
 pgRouting extends the PostGIS/PostgreSQL geospatial database to provide
 geospatial routing and other network analysis functionality.
 .
 This package supports PostgreSQL 9.5.

Package: postgresql-9.6-pgrouting
Architecture: any
Depends: postgresql-9.6-pgrouting-scripts (>= ${source:Version}),
         postgresql-9.6,
         postgresql-9.6-postgis,
         postgresql-9.6-postgis-scripts,
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: postgresql-9.6-pgrouting-doc
Provides: postgresql-pgrouting
Description: Routing functionality support for PostgreSQL/PostGIS
 pgRouting extends the PostGIS/PostgreSQL geospatial database to provide
 geospatial routing and other network analysis functionality.
 .
 This package supports PostgreSQL 9.6.

Package: postgresql-10-pgrouting
Architecture: any
Depends: postgresql-10-pgrouting-scripts (>= ${source:Version}),
         postgresql-10,
         postgresql-10-postgis,
         postgresql-10-postgis-scripts,
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: postgresql-10-pgrouting-doc
Provides: postgresql-pgrouting
Description: Routing functionality support for PostgreSQL/PostGIS
 pgRouting extends the PostGIS/PostgreSQL geospatial database to provide
 geospatial routing and other network analysis functionality.
 .
 This package supports PostgreSQL 10.

Package: postgresql-11-pgrouting
Architecture: any
Depends: postgresql-11-pgrouting-scripts (>= ${source:Version}),
         postgresql-11,
         postgresql-11-postgis,
         postgresql-11-postgis-scripts,
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: postgresql-11-pgrouting-doc
Provides: postgresql-pgrouting
Description: Routing functionality support for PostgreSQL/PostGIS
 pgRouting extends the PostGIS/PostgreSQL geospatial database to provide
 geospatial routing and other network analysis functionality.
 .
 This package supports PostgreSQL 11.

Package: postgresql-12-pgrouting
Architecture: any
Depends: postgresql-12-pgrouting-scripts (>= ${source:Version}),
         postgresql-12,
         postgresql-12-postgis,
         postgresql-12-postgis-scripts,
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: postgresql-12-pgrouting-doc
Provides: postgresql-pgrouting
Description: Routing functionality support for PostgreSQL/PostGIS
 pgRouting extends the PostGIS/PostgreSQL geospatial database to provide
 geospatial routing and other network analysis functionality.
 .
 This package supports PostgreSQL 12.

Package: postgresql-9.4-pgrouting-scripts
Architecture: all
Depends: ${misc:Depends}
Provides: postgresql-pgrouting-scripts
Description: Routing functionality support for PostgreSQL/PostGIS - SQL scripts
 pgRouting extends the PostGIS/PostgreSQL geospatial database to provide
 geospatial routing and other network analysis functionality.
 .
 This package contains the SQL scripts for installing pgRouting, and for
 upgrading from earlier pgRouting versions.
 .
 This package supports PostgreSQL 9.4.

Package: postgresql-9.5-pgrouting-scripts
Architecture: all
Depends: ${misc:Depends}
Provides: postgresql-pgrouting-scripts
Description: Routing functionality support for PostgreSQL/PostGIS - SQL scripts
 pgRouting extends the PostGIS/PostgreSQL geospatial database to provide
 geospatial routing and other network analysis functionality.
 .
 This package contains the SQL scripts for installing pgRouting, and for
 upgrading from earlier pgRouting versions.
 .
 This package supports PostgreSQL 9.5.

Package: postgresql-9.6-pgrouting-scripts
Architecture: all
Depends: ${misc:Depends}
Provides: postgresql-pgrouting-scripts
Description: Routing functionality support for PostgreSQL/PostGIS - SQL scripts
 pgRouting extends the PostGIS/PostgreSQL geospatial database to provide
 geospatial routing and other network analysis functionality.
 .
 This package contains the SQL scripts for installing pgRouting, and for
 upgrading from earlier pgRouting versions.
 .
 This package supports PostgreSQL 9.6.

Package: postgresql-10-pgrouting-scripts
Architecture: all
Depends: ${misc:Depends}
Provides: postgresql-pgrouting-scripts
Description: Routing functionality support for PostgreSQL/PostGIS - SQL scripts
 pgRouting extends the PostGIS/PostgreSQL geospatial database to provide
 geospatial routing and other network analysis functionality.
 .
 This package contains the SQL scripts for installing pgRouting, and for
 upgrading from earlier pgRouting versions.
 .
 This package supports PostgreSQL 10.

Package: postgresql-11-pgrouting-scripts
Architecture: all
Depends: ${misc:Depends}
Provides: postgresql-pgrouting-scripts
Description: Routing functionality support for PostgreSQL/PostGIS - SQL scripts
 pgRouting extends the PostGIS/PostgreSQL geospatial database to provide
 geospatial routing and other network analysis functionality.
 .
 This package contains the SQL scripts for installing pgRouting, and for
 upgrading from earlier pgRouting versions.
 .
 This package supports PostgreSQL 11.

Package: postgresql-12-pgrouting-scripts
Architecture: all
Depends: ${misc:Depends}
Provides: postgresql-pgrouting-scripts
Description: Routing functionality support for PostgreSQL/PostGIS - SQL scripts
 pgRouting extends the PostGIS/PostgreSQL geospatial database to provide
 geospatial routing and other network analysis functionality.
 .
 This package contains the SQL scripts for installing pgRouting, and for
 upgrading from earlier pgRouting versions.
 .
 This package supports PostgreSQL 12.

Package: postgresql-9.4-pgrouting-doc
Architecture: all
Section: doc
Depends: libjs-mathjax,
         ${misc:Depends},
         ${sphinxdoc:Depends}
Description: Routing functionality support for PostgreSQL/PostGIS (Documentation)
 pgRouting extends the PostGIS/PostgreSQL geospatial database to provide
 geospatial routing and other network analysis functionality.
 .
 This package contains the documentation.

Package: postgresql-9.5-pgrouting-doc
Architecture: all
Section: doc
Depends: libjs-mathjax,
         ${misc:Depends},
         ${sphinxdoc:Depends}
Description: Routing functionality support for PostgreSQL/PostGIS (Documentation)
 pgRouting extends the PostGIS/PostgreSQL geospatial database to provide
 geospatial routing and other network analysis functionality.
 .
 This package contains the documentation.

Package: postgresql-9.6-pgrouting-doc
Architecture: all
Section: doc
Depends: libjs-mathjax,
         ${misc:Depends},
         ${sphinxdoc:Depends}
Description: Routing functionality support for PostgreSQL/PostGIS (Documentation)
 pgRouting extends the PostGIS/PostgreSQL geospatial database to provide
 geospatial routing and other network analysis functionality.
 .
 This package contains the documentation.

Package: postgresql-10-pgrouting-doc
Architecture: all
Section: doc
Depends: libjs-mathjax,
         ${misc:Depends},
         ${sphinxdoc:Depends}
Description: Routing functionality support for PostgreSQL/PostGIS (Documentation)
 pgRouting extends the PostGIS/PostgreSQL geospatial database to provide
 geospatial routing and other network analysis functionality.
 .
 This package contains the documentation.

Package: postgresql-11-pgrouting-doc
Architecture: all
Section: doc
Depends: libjs-mathjax,
         ${misc:Depends},
         ${sphinxdoc:Depends}
Description: Routing functionality support for PostgreSQL/PostGIS (Documentation)
 pgRouting extends the PostGIS/PostgreSQL geospatial database to provide
 geospatial routing and other network analysis functionality.
 .
 This package contains the documentation.

Package: postgresql-12-pgrouting-doc
Architecture: all
Section: doc
Depends: libjs-mathjax,
         ${misc:Depends},
         ${sphinxdoc:Depends}
Description: Routing functionality support for PostgreSQL/PostGIS (Documentation)
 pgRouting extends the PostGIS/PostgreSQL geospatial database to provide
 geospatial routing and other network analysis functionality.
 .
 This package contains the documentation.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Enable hardening build flags
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

CFLAGS   += $(CPPFLAGS)
CXXFLAGS += $(CPPFLAGS)

include /usr/share/postgresql-common/pgxs_debian_control.mk

%:
	dh $@ --with sphinxdoc --parallel

override_dh_auto_configure:
	set -e; \
	for v in $$(pg_buildext supported-versions); do \
		cmake -H. -Bbuild-$$v -DWITH_DOC=ON -DPOSTGRESQL_PG_CONFIG=/usr/lib/postgresql/$$v/bin/pg_config -DCMAKE_VERBOSE_MAKEFILE=1; \
	done

override_dh_auto_build:
	+pg_buildext build build-%v
	set -e; \
	for v in $$(pg_buildext supported-versions); do \
		make -C build-$$v doc; \
		rm build-$$v/doc/html/en/_static/images/pgrouting.png; \
		ln -s ../pgrouting.png build-$$v/doc/html/en/_static/images/pgrouting.png; \
		rm build-$$v/doc/html/en/_static/images/ccbysa.png; \
		ln -s ../../_images/ccbysa.png build-$$v/doc/html/en/_static/images/ccbysa.png; \
		ln -s /usr/share/javascript/mathjax build-$$v/doc/html/en/_static/mathjax; \
	done

override_dh_auto_install:
	+pg_buildext install build-%v postgresql-%v-pgrouting
	set -e; \
	for v in $$(pg_buildext supported-versions); do \
		mkdir -p debian/postgresql-$$v-pgrouting-doc/usr/share/doc/postgresql-$$v-pgrouting-doc; \
		cp -r build-$$v/doc/html debian/postgresql-$$v-pgrouting-doc/usr/share/doc/postgresql-$$v-pgrouting-doc; \
		mkdir -p debian/postgresql-$$v-pgrouting-doc/usr/share/doc-base; \
		sed "s,PGVERSION,$$v,g" < debian/postgresql-pgrouting-doc.doc-base.in > debian/postgresql-$$v-pgrouting-doc/usr/share/doc-base/postgresql-$$v-pgrouting-doc; \
		mkdir -p debian/postgresql-$$v-pgrouting-scripts/usr; \
		mv debian/postgresql-$$v-pgrouting/usr/share debian/postgresql-$$v-pgrouting-scripts/usr; \
		rdfind -makeresultsfile false -makehardlinks true \
			debian/postgresql-$$v-pgrouting-scripts/usr/share/postgresql/*/extension; \
	done

override_dh_auto_clean:
	+pg_buildext clean build-%v

override_dh_clean:
	dh_clean debian/postgresql-*-pgrouting.install \
	         debian/postgresql-*-pgrouting-scripts.install

override_dh_sphinxdoc-indep:
	dh_sphinxdoc -Xtheme_extras.js

override_dh_sphinxdoc-arch:

override_dh_install:
	dh_install --list-missing

override_dh_installchangelogs:
	dh_installchangelogs doc/src/release_notes.rst

override_dh_makeshlibs:
	dh_makeshlibs -Xusr/lib/postgresql

=== debian/watch ===
version=3
opts=\
dversionmangle=s/\+(debian|dfsg|ds|deb)\d*$//,\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/;s/RC/rc/,\
filenamemangle=s/(?:.*?)?(?:rel|v|pgrouting)?[\-\_]?(\d\S+)\.(tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))/pgrouting-$1.$2/,\
repacksuffix=+ds \
https://github.com/pgRouting/pgrouting/releases \
(?:.*?/archive/)?(?:rel|v|pgrouting)?[\-\_]?(\d\S+)\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
